diff -Naupr transgui-5.18.0/main.pas transgui/main.pas
--- transgui-5.18.0/main.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/main.pas	2024-11-20 23:40:05.884955303 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit Main;
 {$mode objfpc}{$H+}
 
@@ -32,7 +43,7 @@ uses
   Graphics, Dialogs, ComCtrls, Menus, ActnList, LCLVersion,
   httpsend, StdCtrls, fpjson, jsonparser, ExtCtrls, rpc, syncobjs, variants, varlist, IpResolver,
   zipper, ResTranslator, VarGrid, StrUtils, LCLProc, Grids, BaseForm, utils, AddTorrent, Types,
-  LazFileUtils, LazUTF8, StringToVK, passwcon, GContnrs,lineinfo;
+  LazFileUtils, LazUTF8, StringToVK, passwcon, GContnrs,lineinfo, RegExpr;
 
 const
   AppName = 'Transmission Remote GUI';
@@ -242,8 +253,14 @@ type
     acFilterPane: TAction;
     acMenuShow :  TAction;
     acBigToolbar: TAction;
+    acSetLabels: TAction;
+    acLabelGrouping: TAction;
     ImageList32: TImageList;
     MenuItem103: TMenuItem;
+    MenuItem104: TMenuItem;
+    MenuItem105: TMenuItem;
+    MenuItem106: TMenuItem;
+    MenuItem107: TMenuItem;
     MenuShow: TAction;
     ActionList1: TActionList;
     acToolbarShow :  TAction;
@@ -264,6 +281,8 @@ type
     SearchToolbar: TToolBar;
     tbSearchCancel: TToolButton;
     LocalWatchTimer: TTimer;
+    ToolButton10: TToolButton;
+    txDummy1: TLabel;
     txMagLabel: TLabel;
     txMagnetLink: TEdit;
     MenuItem101: TMenuItem;
@@ -383,6 +402,7 @@ type
     panSearch: TPanel;
     panFilter: TPanel;
     panReconnectFrame: TShape;
+    txDummy: TLabel;
     txReconnectSecs: TLabel;
     txConnError: TLabel;
     MenuItem38: TMenuItem;
@@ -390,6 +410,8 @@ type
     panReconnect: TPanel;
     txLastActive: TLabel;
     txLastActiveLabel: TLabel;
+    txLabels: TLabel;
+    txLabelsLabel: TLabel;
     txTracker: TLabel;
     txTrackerLabel: TLabel;
     txCompletedOn: TLabel;
@@ -434,9 +456,7 @@ type
     txPeersLabel: TLabel;
     txSeeds: TLabel;
     txSeedsLabel: TLabel;
-    txDummy2: TLabel;
     txTrackerUpdate: TLabel;
-    txDummy1: TLabel;
     txRemaining: TLabel;
     txRemainingLabel: TLabel;
     txStatus: TLabel;
@@ -538,6 +558,7 @@ type
     procedure acForceStartTorrentExecute(Sender: TObject);
     procedure acHideAppExecute(Sender: TObject);
     procedure acInfoPaneExecute(Sender: TObject);
+    procedure acLabelGroupingExecute(Sender: TObject);
     procedure acMenuShowExecute(Sender: TObject);
     procedure acMoveTorrentExecute(Sender: TObject);
     procedure acNewConnectionExecute(Sender: TObject);
@@ -564,6 +585,7 @@ type
     procedure acSetLowPriorityExecute(Sender: TObject);
     procedure acSetNormalPriorityExecute(Sender: TObject);
     procedure acSetNotDownloadExecute(Sender: TObject);
+    procedure acSetLabelsExecute(Sender: TObject);
     procedure acSetupColumnsExecute(Sender: TObject);
     procedure acShowAppExecute(Sender: TObject);
     procedure acShowCountryFlagExecute(Sender: TObject);
@@ -830,6 +852,7 @@ const
   idxSeedingTime = 22;
   idxSizeLeft = 23;
   idxPrivate = 24;
+  idxLabels = 25;
 
   idxTag = -1;
   idxSeedsTotal = -2;
@@ -890,11 +913,11 @@ const
 
   StatusFiltersCount = 8;
 
-  TorrentFieldsMap: array[idxName..idxPrivate] of string =
+  TorrentFieldsMap: array[idxName..idxLabels] of string =
     ('', 'totalSize', '', 'status', 'peersSendingToUs,seeders',
     'peersGettingFromUs,leechers', '', '', 'eta', 'uploadRatio',
     'downloadedEver', 'uploadedEver', '', '', 'addedDate', 'doneDate', 'activityDate', '', 'bandwidthPriority',
-    '', '', 'queuePosition', 'secondsSeeding', 'leftUntilDone', 'isPrivate');
+    '', '', 'queuePosition', 'secondsSeeding', 'leftUntilDone', 'isPrivate', 'labels');
 
   FinishedQueue = 1000000;
 
@@ -1538,7 +1561,7 @@ begin
   FTrackers.Sorted:=True;
   FReconnectTimeOut:=-1;
   FAlterColor:=GetLikeColor(gTorrents.Color, -$10);
-  lvFilter.Items.ExtraColumns:=1;
+  lvFilter.Items.ExtraColumns:=2;
   gTorrents.AlternateColor:=FAlterColor;
   lvPeers.AlternateColor:=FAlterColor;
   lvTrackers.AlternateColor:=FAlterColor;
@@ -1689,6 +1712,7 @@ begin
   bidiMode := GetBiDi;
 
   acFolderGrouping.Checked:=Ini.ReadBool('Interface', 'FolderGrouping', True);
+  acLabelGrouping.Checked:=Ini.ReadBool('Interface', 'LabelGrouping', True);
   acTrackerGrouping.Checked:=Ini.ReadBool('Interface', 'TrackerGrouping', True);
   FLinksFromClipboard:=Ini.ReadBool('Interface', 'LinksFromClipboard', True);
   Application.OnActivate:=@FormActivate;
@@ -1995,6 +2019,13 @@ begin
     RpcObj.AdvInfo:=aiNone;
 end;
 
+procedure TMainForm.acLabelGroupingExecute(Sender: TObject);
+begin
+  acLabelGrouping.Checked:=not acLabelGrouping.Checked;
+  Ini.WriteBool('Interface', 'LabelGrouping', acLabelGrouping.Checked);
+  RpcObj.RefreshNow:=RpcObj.RefreshNow + [rtTorrents];
+end;
+
 procedure TMainForm.acMenuShowExecute(Sender: TObject);
 begin
     acMenuShow.Checked:=not acMenuShow.Checked;
@@ -2052,7 +2083,7 @@ begin
           aids.Add(integer(ids[i]));
         args.Add('ids', aids);
         args.Add('location', TJSONString.Create(UTF8Decode(edTorrentDir.Text)));
-        args.Add('move', TJSONIntegerNumber.Create(integer(cbMoveData.Checked) and 1));
+        args.Add('move', cbMoveData.Checked);
         req.Add('arguments', args);
         args:=RpcObj.SendRequest(req, False);
         args.Free;
@@ -2233,7 +2264,7 @@ begin
   try
     req.Add('method', 'session-set');
     args:=TJSONObject.Create;
-    args.Add('alt-speed-enabled', integer(not acAltSpeed.Checked) and 1);
+    args.Add('alt-speed-enabled', not acAltSpeed.Checked);
     req.Add('arguments', args);
     args:=RpcObj.SendRequest(req, False);
     if args = nil then begin
@@ -2642,7 +2673,7 @@ begin
         edSearch.Text:='';
 
         args:=TJSONObject.Create;
-        args.Add('paused', TJSONIntegerNumber.Create(1));
+        args.Add('paused', True);
         i:=Ini.ReadInteger(IniSec, 'PeerLimit', 0);
         if i <> 0 then
           args.Add('peer-limit', TJSONIntegerNumber.Create(i));
@@ -2731,7 +2762,7 @@ begin
             TorrentAction(id, 'torrent-remove');
             id:=0;
             args:=TJSONObject.Create;
-            args.Add('paused', TJSONIntegerNumber.Create(1));
+            args.Add('paused', True);
             args.Add('peer-limit', TJSONIntegerNumber.Create(edPeerLimit.Value));
             args.Add('download-dir', TJSONString.Create(UTF8Decode(cbDestFolder.Text)));
             id:=_AddTorrent(args);
@@ -3340,18 +3371,18 @@ begin
           if RpcObj.RPCVersion >= 5 then begin
             // RPC version 5
             edPort.Value:=args.Integers['peer-port'];
-            cbPEX.Checked:=args.Integers['pex-enabled'] <> 0;
+            cbPEX.Checked:=args.Booleans['pex-enabled'];
             edMaxPeers.Value:=args.Integers['peer-limit-global'];
-            cbRandomPort.Checked:=args.Integers['peer-port-random-on-start'] <> 0;
-            cbDHT.Checked:=args.Integers['dht-enabled'] <> 0;
-            cbSeedRatio.Checked:=args.Integers['seedRatioLimited'] <> 0;
+            cbRandomPort.Checked:=args.Booleans['peer-port-random-on-start'];
+            cbDHT.Checked:=args.Booleans['dht-enabled'];
+            cbSeedRatio.Checked:=args.Booleans['seedRatioLimited'];
             edSeedRatio.Value:=args.Floats['seedRatioLimit'];
-            cbBlocklist.Checked:=args.Integers['blocklist-enabled'] <> 0;
+            cbBlocklist.Checked:=args.Booleans['blocklist-enabled'];
 
-            cbAltEnabled.Checked:=args.Integers['alt-speed-enabled'] <> 0;
+            cbAltEnabled.Checked:=args.Booleans['alt-speed-enabled'];
             edAltDown.Value:=args.Integers['alt-speed-down'];
             edAltUp.Value:=args.Integers['alt-speed-up'];
-            cbAutoAlt.Checked:=args.Integers['alt-speed-time-enabled'] <> 0;
+            cbAutoAlt.Checked:=args.Booleans['alt-speed-time-enabled'];
             edAltTimeBegin.Text:=FormatDateTime('hh:nn', args.Integers['alt-speed-time-begin']/MinsPerDay);
             edAltTimeEnd.Text:=FormatDateTime('hh:nn', args.Integers['alt-speed-time-end']/MinsPerDay);
             j:=args.Integers['alt-speed-time-day'];
@@ -3377,7 +3408,7 @@ begin
           end;
 
           if RpcObj.RPCVersion >= 7 then begin
-            cbIncompleteDir.Checked:=args.Integers['incomplete-dir-enabled'] <> 0;
+            cbIncompleteDir.Checked:=args.Booleans['incomplete-dir-enabled'];
             edIncompleteDir.Text:=UTF8Encode(args.Strings['incomplete-dir']);
             cbIncompleteDirClick(nil);
           end
@@ -3387,18 +3418,18 @@ begin
           end;
 
           if RpcObj.RPCVersion >= 8 then
-            cbPartExt.Checked:=args.Integers['rename-partial-files'] <> 0
+            cbPartExt.Checked:=args.Booleans['rename-partial-files']
           else
             cbPartExt.Visible:=False;
 
           if RpcObj.RPCVersion >= 9 then
-            cbLPD.Checked:=args.Integers['lpd-enabled'] <> 0
+            cbLPD.Checked:=args.Booleans['lpd-enabled']
           else
             cbLPD.Visible:=False;
 
           if RpcObj.RPCVersion >= 10 then begin
             edCacheSize.Value:=args.Integers['cache-size-mb'];
-            cbIdleSeedLimit.Checked:=args.Integers['idle-seeding-limit-enabled'] <> 0;
+            cbIdleSeedLimit.Checked:=args.Booleans['idle-seeding-limit-enabled'];
             edIdleSeedLimit.Value:=args.Integers['idle-seeding-limit'];
             cbIdleSeedLimitClick(nil);
           end
@@ -3421,23 +3452,23 @@ begin
           cbBlocklistClick(nil);
 
           if RpcObj.RPCVersion >= 13 then
-            cbUTP.Checked:=args.Integers['utp-enabled'] <> 0
+            cbUTP.Checked:=args.Booleans['utp-enabled']
           else
             cbUTP.Visible:=False;
 
           if RpcObj.RPCVersion >= 14 then begin
             tabQueue.TabVisible:=True;
-            cbDownQueue.Checked:=args.Integers['download-queue-enabled'] <> 0;
+            cbDownQueue.Checked:=args.Booleans['download-queue-enabled'];
             edDownQueue.Value:=args.Integers['download-queue-size'];
-            cbUpQueue.Checked:=args.Integers['seed-queue-enabled'] <> 0;
+            cbUpQueue.Checked:=args.Booleans['seed-queue-enabled'];
             edUpQueue.Value:=args.Integers['seed-queue-size'];
-            cbStalled.Checked:=args.Integers['queue-stalled-enabled'] <> 0;
+            cbStalled.Checked:=args.Booleans['queue-stalled-enabled'];
             edStalledTime.Value:=args.Integers['queue-stalled-minutes'];
           end
           else
             tabQueue.TabVisible:=False;
 
-          cbPortForwarding.Checked:=args.Integers['port-forwarding-enabled'] <> 0;
+          cbPortForwarding.Checked:=args.Booleans['port-forwarding-enabled'];
           s:=args.Strings['encryption'];
           if s = 'preferred' then
             cbEncryption.ItemIndex:=1
@@ -3446,9 +3477,9 @@ begin
             cbEncryption.ItemIndex:=2
           else
             cbEncryption.ItemIndex:=0;
-          cbMaxDown.Checked:=args.Integers['speed-limit-down-enabled'] <> 0;
+          cbMaxDown.Checked:=args.Booleans['speed-limit-down-enabled'];
           edMaxDown.Value:=args.Integers['speed-limit-down'];
-          cbMaxUp.Checked:=args.Integers['speed-limit-up-enabled'] <> 0;
+          cbMaxUp.Checked:=args.Booleans['speed-limit-up-enabled'];
           edMaxUp.Value:=args.Integers['speed-limit-up'];
         finally
           args.Free;
@@ -3474,34 +3505,34 @@ begin
         req.Add('method', 'session-set');
         args:=TJSONObject.Create;
         args.Add('download-dir', UTF8Decode(edDownloadDir.Text));
-        args.Add('port-forwarding-enabled', integer(cbPortForwarding.Checked) and 1);
+        args.Add('port-forwarding-enabled', cbPortForwarding.Checked);
         case cbEncryption.ItemIndex of
           1: s:='preferred';
           2: s:='required';
           else s:='tolerated';
         end;
         args.Add('encryption', s);
-        args.Add('speed-limit-down-enabled', integer(cbMaxDown.Checked) and 1);
+        args.Add('speed-limit-down-enabled', cbMaxDown.Checked);
         if cbMaxDown.Checked then
           args.Add('speed-limit-down', edMaxDown.Value);
-        args.Add('speed-limit-up-enabled', integer(cbMaxUp.Checked) and 1);
+        args.Add('speed-limit-up-enabled', cbMaxUp.Checked);
         if cbMaxUp.Checked then
           args.Add('speed-limit-up', edMaxUp.Value);
         if RpcObj.RPCVersion >= 5 then begin
           args.Add('peer-limit-global', edMaxPeers.Value);
           args.Add('peer-port', edPort.Value);
-          args.Add('pex-enabled', integer(cbPEX.Checked) and 1);
-          args.Add('peer-port-random-on-start', integer(cbRandomPort.Checked) and 1);
-          args.Add('dht-enabled', integer(cbDHT.Checked) and 1);
-          args.Add('seedRatioLimited', integer(cbSeedRatio.Checked) and 1);
+          args.Add('pex-enabled', cbPEX.Checked);
+          args.Add('peer-port-random-on-start', cbRandomPort.Checked);
+          args.Add('dht-enabled', cbDHT.Checked);
+          args.Add('seedRatioLimited', cbSeedRatio.Checked);
           if cbSeedRatio.Checked then
             args.Add('seedRatioLimit', edSeedRatio.Value);
-          args.Add('blocklist-enabled', integer(cbBlocklist.Checked) and 1);
+          args.Add('blocklist-enabled', cbBlocklist.Checked);
 
-          args.Add('alt-speed-enabled', integer(cbAltEnabled.Checked) and 1);
+          args.Add('alt-speed-enabled', cbAltEnabled.Checked);
           args.Add('alt-speed-down', edAltDown.Value);
           args.Add('alt-speed-up', edAltUp.Value);
-          args.Add('alt-speed-time-enabled', integer(cbAutoAlt.Checked) and 1);
+          args.Add('alt-speed-time-enabled', cbAutoAlt.Checked);
           if cbAutoAlt.Checked then begin
             args.Add('alt-speed-time-begin', Round(Frac(StrToTime(edAltTimeBegin.Text))*MinsPerDay));
             args.Add('alt-speed-time-end', Round(Frac(StrToTime(edAltTimeEnd.Text))*MinsPerDay));
@@ -3516,33 +3547,33 @@ begin
         else begin
           args.Add('peer-limit', edMaxPeers.Value);
           args.Add('port', edPort.Value);
-          args.Add('pex-allowed', integer(cbPEX.Checked) and 1);
+          args.Add('pex-allowed', cbPEX.Checked);
         end;
         if RpcObj.RPCVersion >= 7 then begin
-          args.Add('incomplete-dir-enabled', integer(cbIncompleteDir.Checked) and 1);
+          args.Add('incomplete-dir-enabled', cbIncompleteDir.Checked);
           if cbIncompleteDir.Checked then
             args.Add('incomplete-dir', UTF8Decode(edIncompleteDir.Text));
         end;
         if RpcObj.RPCVersion >= 8 then
-          args.Add('rename-partial-files', integer(cbPartExt.Checked) and 1);
+          args.Add('rename-partial-files', cbPartExt.Checked);
         if RpcObj.RPCVersion >= 9 then
-          args.Add('lpd-enabled', integer(cbLPD.Checked) and 1);
+          args.Add('lpd-enabled', cbLPD.Checked);
         if RpcObj.RPCVersion >= 10 then begin
           args.Add('cache-size-mb', edCacheSize.Value);
-          args.Add('idle-seeding-limit-enabled', integer(cbIdleSeedLimit.Checked) and 1);
+          args.Add('idle-seeding-limit-enabled', cbIdleSeedLimit.Checked);
           args.Add('idle-seeding-limit', edIdleSeedLimit.Value);
         end;
         if edBlocklistURL.Visible then
           if cbBlocklist.Checked then
             args.Add('blocklist-url', UTF8Decode(edBlocklistURL.Text));
         if RpcObj.RPCVersion >= 13 then
-          args.Add('utp-enabled', integer(cbUTP.Checked) and 1);
+          args.Add('utp-enabled', cbUTP.Checked);
         if RpcObj.RPCVersion >= 14 then begin
-          args.Add('download-queue-enabled', integer(cbDownQueue.Checked) and 1);
+          args.Add('download-queue-enabled', cbDownQueue.Checked);
           args.Add('download-queue-size', edDownQueue.Value);
-          args.Add('seed-queue-enabled', integer(cbUpQueue.Checked) and 1);
+          args.Add('seed-queue-enabled', cbUpQueue.Checked);
           args.Add('seed-queue-size', edUpQueue.Value);
-          args.Add('queue-stalled-enabled', integer(cbStalled.Checked) and 1);
+          args.Add('queue-stalled-enabled', cbStalled.Checked);
           args.Add('queue-stalled-minutes', edStalledTime.Value);
         end;
 
@@ -3668,6 +3699,70 @@ begin
   SetCurrentFilePriority('skip');
 end;
 
+procedure TMainForm.acSetLabelsExecute(Sender: TObject);
+var
+  ids: variant;
+  i: integer;
+  input, s: string;
+  req: TJSONObject;
+  aids: TJSONArray;
+  alabels: TJSONArray;
+  slabels: TStringList;
+  args: TJSONObject;
+begin
+  if gTorrents.Items.Count = 0 then
+    exit;
+  gTorrents.Tag:=1;
+  gTorrents.EnsureSelectionVisible;
+  if gTorrents.SelCount = 0 then
+    gTorrents.RowSelected[gTorrents.Row]:=True;
+  ids:=GetSelectedTorrents;
+  i:=gTorrents.Items.IndexOf(idxTorrentId, ids[0]);
+  if VarIsEmpty(gTorrents.Items[idxPath, i]) then
+    exit;
+  if InputQuery('Set labels',
+      'This will overwrite any existing labels.' + sLineBreak +
+      'You can set multiple labels separated by a comma or leave empty to clear labels.',
+      input) then begin
+    AppBusy;
+    req := TJSONObject.Create;
+    args := TJSONObject.Create;
+    aids := TJSONArray.Create;
+    alabels := TJSONArray.Create;
+    slabels := TStringList.Create;
+    try
+      req.Add('method', 'torrent-set');
+      for i:=VarArrayLowBound(ids, 1) to VarArrayHighBound(ids, 1) do
+            aids.Add(integer(ids[i]));
+      args.Add('ids', aids);
+      if trim(input) <> '' then begin
+        SplitRegExpr(',', input, slabels);
+        slabels.Sort;
+      end;
+      for s in slabels do begin
+        alabels.Add(trim(s));
+      end;
+      args.Add('labels', alabels);
+      req.Add('arguments', args);
+      args := RpcObj.SendRequest(req, False);
+      args.Free;
+    finally
+      req.Free;
+      AppNormal;
+    end;
+    if args = nil then
+      CheckStatus(False)
+    else begin
+      RpcObj.RequestFullInfo:=True;
+      DoRefresh(True);
+      Sleep(200);
+      Application.ProcessMessages;
+    end;
+
+  end;
+  gTorrents.Tag:=0;
+end;
+
 procedure TMainForm.acSetupColumnsExecute(Sender: TObject);
 var
   g: TVarGrid;
@@ -3976,16 +4071,16 @@ begin
         if RpcObj.RPCVersion < 5 then
         begin
           // RPC versions prior to v5
-          args.Add('speed-limit-down-enabled', integer(cbMaxDown.Checked) and 1);
-          args.Add('speed-limit-up-enabled', integer(cbMaxUp.Checked) and 1);
+          args.Add('speed-limit-down-enabled', cbMaxDown.Checked);
+          args.Add('speed-limit-up-enabled', cbMaxUp.Checked);
           if cbMaxDown.Checked then
             args.Add('speed-limit-down', edMaxDown.Value);
           if cbMaxUp.Checked then
             args.Add('speed-limit-up', edMaxUp.Value);
         end else begin
           // RPC version 5
-          args.Add('downloadLimited', integer(cbMaxDown.Checked) and 1);
-          args.Add('uploadLimited', integer(cbMaxUp.Checked) and 1);
+          args.Add('downloadLimited', cbMaxDown.Checked);
+          args.Add('uploadLimited', cbMaxUp.Checked);
           if cbMaxDown.Checked then
             args.Add('downloadLimit', edMaxDown.Value);
           if cbMaxUp.Checked then
@@ -4530,6 +4625,7 @@ begin
 end;
 
 procedure TMainForm.lvFilterCellAttributes(Sender: TVarGrid; ACol, ARow, ADataCol: integer; AState: TGridDrawState; var CellAttribs: TCellAttributes);
+var t: Integer;
 begin
   if ARow < 0 then exit;
   with CellAttribs do begin
@@ -4546,8 +4642,13 @@ begin
         if Text <> '' then
           if VarIsNull(Sender.Items[-1, ARow]) then
             ImageIndex:=5
-          else
-            ImageIndex:=22;
+          else begin
+            t:=Integer(Sender.Items[-2, ARow]);
+            if t = 1 then
+              ImageIndex:=22
+            else
+              ImageIndex:=44;
+          end;
     end;
   end;
 end;
@@ -5284,6 +5385,7 @@ begin
   acRemoveTorrentAndData.Enabled:=acRemoveTorrent.Enabled and (RpcObj.RPCVersion >= 4);
   acReannounceTorrent.Enabled:=acVerifyTorrent.Enabled and (RpcObj.RPCVersion >= 5);
   acMoveTorrent.Enabled:=acVerifyTorrent.Enabled and (RpcObj.RPCVersion >= 6);
+  acSetLabels.Enabled:=acVerifyTorrent.Enabled and (RpcObj.RPCVersion >= 16);
   acTorrentProps.Enabled:=acVerifyTorrent.Enabled;
   acOpenContainingFolder.Enabled:=acTorrentProps.Enabled and (RpcObj.RPCVersion >= 4);
   pmiPriority.Enabled:=e and (gTorrents.Items.Count > 0);
@@ -5553,8 +5655,9 @@ end;
 
 procedure TMainForm.FillTorrentsList(list: TJSONArray);
 var
-  i, j, row, crow, id, StateImg: integer;
+  i, j, p, row, crow, id, StateImg: integer;
   t: TJSONObject;
+  a: TJSONArray;
   f: double;
   ExistingRow: boolean;
   s, ss: string;
@@ -5640,11 +5743,11 @@ var
 
 var
   FilterIdx, OldId: integer;
-  TrackerFilter, PathFilter: string;
+  TrackerFilter, PathFilter, LabelFilter: string;
   UpSpeed, DownSpeed: double;
-  DownCnt, SeedCnt, CompletedCnt, ActiveCnt, StoppedCnt, ErrorCnt, WaitingCnt: integer;
+  DownCnt, SeedCnt, CompletedCnt, ActiveCnt, StoppedCnt, ErrorCnt, WaitingCnt, ft: integer;
   IsActive: boolean;
-  Paths: TStringList;
+  Paths, Labels: TStringList;
   v: variant;
   FieldExists: array of boolean;
 begin
@@ -5668,8 +5771,11 @@ begin
   end;
 }
   Paths:=TStringList.Create;
+  Labels:=TStringList.Create;
   try
   Paths.Sorted:=True;
+  Labels.Sorted:=True;
+  Labels.CaseSensitive:=True;
   OldId:=RpcObj.CurTorrentId;
   IsActive:=gTorrents.Enabled;
   gTorrents.Enabled:=True;
@@ -5696,6 +5802,7 @@ begin
     FieldExists[idxQueuePos]:=t.IndexOfName('queuePosition') >= 0;
     FieldExists[idxSeedingTime]:=t.IndexOfName('secondsSeeding') >= 0;
     FieldExists[idxPrivate]:=t.IndexOfName('isPrivate') >= 0;
+    FIeldExists[idxLabels]:=t.IndexOfName('labels') >= 0;
   end;
 
   UpSpeed:=0;
@@ -5713,7 +5820,11 @@ begin
     Dec(FilterIdx);
   if FilterIdx >= StatusFiltersCount then
     if not VarIsNull(lvFilter.Items[-1, FilterIdx]) then begin
-      PathFilter:=UTF8Encode(widestring(lvFilter.Items[-1, FilterIdx]));
+      ft := Integer(lvFilter.Items[-2, FilterIdx]);
+      if ft = 1 then
+        PathFilter:=UTF8Encode(widestring(lvFilter.Items[-1, FilterIdx]))
+      else
+        LabelFilter:=UTF8Encode(widestring(lvFilter.Items[-1, FilterIdx]));
       FilterIdx:=fltAll;
     end
     else begin
@@ -5934,7 +6045,23 @@ begin
     end;
 
     if FieldExists[idxPrivate] then
-      FTorrents[idxPrivate, row]:=t.Integers['isPrivate'];
+      FTorrents[idxPrivate, row]:=t.Integers['isPrivate']; { boolean in json, but must be integer in varlist }
+
+    if FieldExists[idxLabels] then begin
+      a := t.Arrays['labels'];
+      s := '';
+      for j:=0 to a.Count-1 do begin
+        ss := UTF8Encode(widestring(a.Strings[j]));
+        if j > 0 then s := s + ', ';
+        s := s + ss;
+        p := Labels.IndexOf(ss);
+        if p < 0 then
+          Labels.AddObject(ss, TObject(1))
+        else
+          Labels.Objects[p]:=TObject(PtrInt(Labels.Objects[p]) + 1);
+      end;
+      FTorrents[idxLabels, row] := s;
+    end;
 
     DownSpeed:=DownSpeed + FTorrents[idxDownSpeed, row];
     UpSpeed:=UpSpeed + FTorrents[idxUpSpeed, row];
@@ -5996,6 +6123,11 @@ begin
       if (PathFilter <> '') and not VarIsEmpty(FTorrents[idxPath, i]) and (UTF8Decode(PathFilter) <> FTorrents[idxPath, i]) then
         continue;
 
+      if (LabelFilter <> '') and not VarIsEmpty(FTorrents[idxLabels, i]) then begin
+        if not AnsiContainsStr(String(FTorrents[idxLabels, i]), LabelFilter) then
+          continue;
+      end;
+
       case FilterIdx of
         fltActive:
           if not IsActive then
@@ -6085,12 +6217,28 @@ begin
           end;
         lvFilter.Items[ 0, j]:=UTF8Decode(Format('%s (%d)', [s, ptruint(Paths.Objects[i])]));
         lvFilter.Items[-1, j]:=UTF8Decode(Paths[i]);
+        lvFilter.Items[-2, j]:=1;
         if Paths[i] = PathFilter then
           crow:=j;
         Inc(j);
       end;
     end;
 
+    if acLabelGrouping.Checked then begin
+      lvFilter.Items[0, j]:=NULL;
+      Inc(j);
+
+      for i:=0 to Labels.Count - 1 do begin
+        lvFilter.Items[0, j]:=UTF8Decode(Format('%s (%d)', [Labels[i], ptruint(Labels.Objects[i])]));
+        lvFilter.Items[-1, j]:=UTF8Decode(Labels[i]);
+        lvFilter.Items[-2, j]:=2;
+        if Labels[i] = LabelFilter then
+          crow:=j;
+        Inc(j);
+      end;
+
+    end;
+
     row:=j;
 
     if acTrackerGrouping.Checked then begin
@@ -6105,6 +6253,7 @@ begin
         if j > 0 then begin
           lvFilter.Items[ 0, row]:=UTF8Decode(Format('%s (%d)', [FTrackers[i], j]));
           lvFilter.Items[-1, row]:=NULL;
+          lvFilter.Items[-2, row]:=3;
           if FTrackers[i] = TrackerFilter then
             crow:=row;
           Inc(i);
@@ -6298,8 +6447,7 @@ begin
     gTorrents.Tag:=0;
   end;
   args:=TJSONObject.Create;
-  if RemoveLocalData then
-    args.Add('delete-local-data', TJSONIntegerNumber.Create(1));
+  args.Add('delete-local-data', RemoveLocalData);
 
   if TorrentAction(ids, 'torrent-remove', args) then begin
     with gTorrents do begin
@@ -6365,6 +6513,7 @@ var
   s: string;
   tr: string;
   f: double;
+  ja: TJSONArray;
 begin
   if (gTorrents.Items.Count = 0) or (t = nil) then begin
     ClearDetailsInfo;
@@ -6573,6 +6722,18 @@ begin
   txCompletedOn.Caption:=TorrentDateTimeToString(Trunc(t.Floats['doneDate']),FFromNow);
   txCompletedOn.Hint:=TorrentDateTimeToString(Trunc(t.Floats['doneDate']),Not(FFromNow));
   panGeneralInfo.ChildSizing.Layout:=cclLeftToRightThenTopToBottom;
+
+  if t.IndexOfName('labels') >= 0 then begin
+    ja:=t.Arrays['labels'];
+    s:='';
+    for i:=0 to ja.Count-1 do begin
+      if i > 0 then begin
+        s := s + ', ';
+      end;
+      s := s + ja.Strings[i];
+    end;
+    txLabels.Caption := s;
+  end;
   DetailsUpdated;
 end;
 
@@ -6721,12 +6882,12 @@ begin
 
   if RpcObj.RPCVersion >= 5 then begin
 {$ifdef LCLcarbon}
-    if acAltSpeed.Checked <> (s.Integers['alt-speed-enabled'] <> 0) then
+    if acAltSpeed.Checked <> (s.Booleans['alt-speed-enabled']) then
       TrayIcon.Tag:=1;
 {$endif LCLcarbon}
-    acAltSpeed.Checked:=s.Integers['alt-speed-enabled'] <> 0;
-    acUpdateBlocklist.Tag:=s.Integers['blocklist-enabled'];
-    acUpdateBlocklist.Enabled:=acUpdateBlocklist.Tag <> 0;
+    acAltSpeed.Checked:=s.Booleans['alt-speed-enabled'];
+    if s.Booleans['blocklist-enabled'] then acUpdateBlocklist.Tag:=1 else acUpdateBlocklist.Tag:=0;
+    acUpdateBlocklist.Enabled:=s.Booleans['blocklist-enabled'];
   end;
   if s.IndexOfName('download-dir-free-space') >= 0 then
     StatusBar.Panels[3].Text:=Format(SFreeSpace, [GetHumanSize(s.Floats['download-dir-free-space'])]);
@@ -6736,11 +6897,11 @@ begin
     u:=s.Integers['alt-speed-up']
   end
   else begin
-    if s.Integers['speed-limit-down-enabled'] <> 0 then
+    if s.Booleans['speed-limit-down-enabled'] then
       d:=s.Integers['speed-limit-down']
     else
       d:=-1;
-    if s.Integers['speed-limit-up-enabled'] <> 0 then
+    if s.Booleans['speed-limit-up-enabled'] then
       u:=s.Integers['speed-limit-up']
     else
       u:=-1;
@@ -7565,7 +7726,7 @@ begin
     args.Add(Format('speed-limit-%s-enabled', [Dir]), integer(Speed >= 0) and 1);
     if Speed >= 0 then
       args.Add(Format('speed-limit-%s', [Dir]), Speed);
-    args.Add('alt-speed-enabled', 0);
+    args.Add('alt-speed-enabled', False);
     req.Add('arguments', args);
     args:=RpcObj.SendRequest(req, False);
     if args = nil then begin
diff -Naupr transgui-5.18.0/movetorrent.pas transgui/movetorrent.pas
--- transgui-5.18.0/movetorrent.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/movetorrent.pas	2024-11-20 23:40:05.884955303 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit MoveTorrent;
 
 {$mode objfpc}{$H+}
diff -Naupr transgui-5.18.0/options.pas transgui/options.pas
--- transgui-5.18.0/options.pas	2019-10-12 12:52:07.000000000 +0700
+++ transgui/options.pas	2024-11-20 23:40:05.884955303 +0700
@@ -15,8 +15,19 @@
   You should have received a copy of the GNU General Public License
   along with Transmission Remote GUI; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-*************************************************************************************}
 
+  In addition, as a special exception, the copyright holders give permission to 
+  link the code of portions of this program with the
+  OpenSSL library under certain conditions as described in each individual
+  source file, and distribute linked combinations including the two.
+
+  You must obey the GNU General Public License in all respects for all of the
+  code used other than OpenSSL.  If you modify file(s) with this exception, you
+  may extend this exception to your version of the file(s), but you are not
+  obligated to do so.  If you do not wish to do so, delete this exception
+  statement from your version.  If you delete this exception statement from all
+  source files in the program, then also delete it here.
+*************************************************************************************}
 unit Options;
 
 {$mode objfpc}{$H+}
